#!/usr/bin/env python
# -*- coding: Latin-1 -*-
import user
import os
import re
import sys
from xml.dom import minidom
from dcopamarok import dcop_amarok


# the fields to be shown via http
FIELDS = ("sqlquery","name")


class SmartPlaylist(object):
    __slots__ = FIELDS

    def __init__(self, **kwargs):
        for key,value in kwargs.iteritems():
            setattr(self, key, value)
	    
    def __str__(self):
	    return "Smart playlist %s: %s"%(self.name,self.sqlquery)


class SmartPlaylistCollection:

    def __init__(self):
        """The Constructor takes no arguments."""
	path = os.path.dirname(dcop_amarok("playlist","saveCurrentPlaylist"))
	self.pathname = os.path.join(path,"smartplaylistbrowser_save.xml")
        self.playlists = []
        self.mtime = None
        self.reread()

    def __getitem__(self,playlist_name):
	 for a in self.playlists:
	 	if a.name == playlist_name: return a
	 raise KeyError,playlist_name

    def has_changed(self):
	    if self.mtime != os.stat(self.pathname)[-2]: return True
	    return False

    def reread(self):
	    if self.has_changed():
		    import logging
		    logging.getLogger(str(self.__class__)).debug("Changed: rereading")
		    self.mtime = os.stat(self.pathname)[-2]
		    self._buildDoc()

    def _buildDoc(self):
        """Build the DOM-doc and calls the _extractPlaylists-Method"""
	self.doc = minidom.parse(self.pathname)
        self._extractPlaylists()

    def _extractPlaylists(self):
        self.playlists = []
        append = self.playlists.append
        for item in self.doc.getElementsByTagName("smartplaylist"):
            curPlaylist = SmartPlaylist()
            for elem in FIELDS:
                try:
                    value = item.getElementsByTagName(elem)[0].firstChild.nodeValue
                except:
                    value = '  '
                if elem == "sqlquery":
			value = re.sub("ORDER BY .*","",value)
			value = re.sub("SELECT .* FROM ","SELECT tags.url FROM ",value)
			value = re.sub(";","",value)
			setattr(curPlaylist, elem, value.encode(sys.getfilesystemencoding()))    
		else:
			setattr(curPlaylist, elem, value.encode(sys.getfilesystemencoding()))    
            name = item.getAttribute("name").encode(sys.getfilesystemencoding())
	    setattr(curPlaylist,"name",name)
            append(curPlaylist)

if __name__ == "__main__":
	t = SmartPlaylistCollection()
	for a in t.playlists: print a